#define moving   skill15
#define lookdir  skill16
#define health   skill17
#define npc 	  skill18
#define can_jump skill19

#include "swtch.c"
var anim;

function ent_left(ENTITY* ent)
{
	ent.lookdir=0;
//	if(ent==player)camera.pan+=2*time_step;
	pXent_rotate(ent,NULL,vector(90,0,0));
	pXent_move(ent,vector(15*time_step,0,0),NULL);
	ent.moving=1;
}
function ent_right(ENTITY* ent)
{
	ent.lookdir=1;
//	if(ent==player)camera.pan-=2*time_step;
	pXent_rotate(ent,NULL,vector(-90,0,0));
	pXent_move(ent,vector(15*time_step,0,0),NULL);
	ent.moving=1;
}

function jump(ENTITY* ent)
{
	int iterate;
	if(ent.can_jump)//only jump when in contact with a jumping block
	{
		ent.can_jump=0;
		for(iterate=0;iterate<10;iterate+=1)
		{
			pXent_addvelcentral(ent,vector(0,0,20));
		}
	}
}
function physx_control(ENTITY* ent,VECTOR* hull_scale)
{
	set(ent,PASSABLE);
	VECTOR oldscale;
	vec_set(oldscale,ent.scale_x);
	vec_set(ent.scale_x,vector(hull_scale.x,hull_scale.y,hull_scale.z));
	pXent_settype(ent,PH_RIGID,PH_CAPSULE);
	vec_set(ent.scale_x,oldscale.x);
	pXent_setbodyflag(ent,NX_BF_FROZEN_ROT |NX_BF_FROZEN_POS_X, 1);
	pXent_setmass(ent,0);
	pXent_setdamping (ent,0,0);
	pXent_setfriction(ent,0);
	ent.health=100;
	if(ent!=player)ent.npc=1;
	if(ent!=player)pXent_setgroup(ent,3);
	while(ent.health>0)
	{
		proc_mode =PROC_EARLY;ent.moving=0;
		if(ent==player)
		{	
			anim += 10 *0.5* time_step;
			anim %= 100;
			if(key_w)jump(ent);
			if(key_a)ent_left(ent);
			if(key_d)ent_right(ent);
			if(ent.moving)	ent_animate(ent,"run",anim, ANM_CYCLE);
			else ent_animate(ent,"stand",anim, ANM_CYCLE);
			camera.pan = clamp(camera.pan, -12,12);
			vec_set(camera.x,vector(player.x-10000,player.y,player.z+40));
		}
		else
		{
			if(ent.lookdir==0)ent_left(ent);
			if(ent.lookdir==1)ent_right(ent);
			if(ent.moving)	ent_animate(ent,"run",anim, ANM_CYCLE);
			else	ent_animate(ent,"stand",anim, ANM_CYCLE);
		}
	wait(1);
	}

}
action set_player()
{
	player=me;me.lookdir=1;physx_control(player,vector(1,1,0.7));
}
action set_enemy()
{
	me.lookdir=1;physx_control(me,vector(1,1,0.7));
}
